import store from "@/store";
import ReadCameraPage from "@/pages/ReadCameraPage.vue";
import ReadListPage from "@/pages/ReadListPage.vue";


const appRoutes = [
    {
        path: "/",
        alias: "/home",
        name: "home",
        component: () => import('@/pages/HomePage.vue'),
        beforeEnter: (to:any, from:any, next:any) => {
            if (store.getters.isAuthenticated) {
                next("/shop");
            } else {
                next();
            }
        }
    },
    {
        path: "/read/cameara/:id",
        name: "ReadProduct",
        component: ReadCameraPage,
        props: true,
        meta: {
            requiresAuth: false,
           // enterTransition: "rubberBand"
        }

    },

    {
        path: "/list",
        component: ReadListPage,
        props: true,
        meta: {
            requiresAuth: false,
            // enterTransition: "rubberBand"
        }

    },
]

export default appRoutes;