import {ActionContext} from "vuex";
import * as seed from "@/seed";

const state = {
    isInitialized: false,
    cameras: [],
    brands: [],
    shapes: [],
    buildtypes: []

};
const getters = {
    cameras: (state: any) => state.cameras,
    camera: (state: any) => (id: any) => state.cameras.find((camera: any) => camera.id === id),
    activeCamera: (state: any) => state.cameras.find((camera:any) => camera.active ),

    brands: (state: any) => state.brands,
    brand: (state: any) => (id: any) => state.brands.find((brand: any) => brand.schluessel === id),

    shapes: (state: any) => state.shapes,
    shape: (state: any) => (id: any) => state.shapes.find((shape: any) => shape.schluessel === id),

    buildtypes: (state: any) => state.buildtypes,
    buildtype: (state: any) => (id: any) => state.buildtypes.find((buildtype: any) => buildtype.schluessel === id),

    isInitialized: (state:any ) => state.isInitialized,

};
const mutations = {
    setCameras(state:any, payload:any) {
        console.log("mutation.setCameras");
        const camerasDA = [];
        payload.map((camera:any) => {
            state.cameras.push({
                ...camera,
                edit: false,
                active: false
            })
        })
        console.log("STORE", state.cameras);
    },
    setCameraActiveState(state:any, payload:any) {
        state.cameras.map((camera:any) => camera.active= false);
        const objCamera = state.cameras.find((camera:any) => camera.id === payload.id);
        objCamera.active = payload.active;
    },
    setBrands(state:any, payload:any) {
        console.log("mutation.setBrands");
        state.brands = payload;
        console.log("STORE", state.brands);
    },
    setShapes(state:any, payload:any) {
        console.log("mutation.setShapes");
        state.shapes = payload;
        console.log("STORE", state.shapes);
    },
    setBuildtypes(state:any, payload:any) {
        console.log("mutation.setBuildtypes");
        state.buildtypes = payload;
        console.log("STORE", state.buildtypes);
    },
    setInitialized(state:any, payload:boolean) {
        state.isInitialized = payload;
    }
};
const actions = {
    fetchCameras(context:ActionContext<any, any>) {
        context.commit("setCameras", seed.cameras);
    },
    fetchBrands(context:ActionContext<any, any>) {
        context.commit("setBrands", seed.brands);
    },
    fetchBuildTypes(context:ActionContext<any, any>) {
        context.commit("setBuildtypes", seed.buildtype);
    },
    fetchShape(context:ActionContext<any, any>) {
        context.commit("setShapes", seed.shape);
    },
    setCameraActiveState(context:ActionContext<any, any>, payload:any) {
        console.log("action.setCameraActiveState", payload)
        const cameraObj = state.cameras.find( (camera:any) => camera.id === payload.cameraId);
        context.commit("setCameraActiveState", {id: payload.cameraId, active:payload.active});

    },
    initialize(context:ActionContext<any, any>) {
        context.dispatch("fetchCameras");
        context.dispatch("fetchBrands");
        context.dispatch("fetchBuildTypes");
        context.dispatch("fetchShape");
        context.commit("setInitialized", true);

    }
};
const modules = {};

const cameraModule = {
    state,
    getters,
    mutations,
    actions,
    modules
}

export default cameraModule